#include <windows.h>
#include <winsock.h>

#define NETWORK_ERROR 0
#define NETWORK_OK    1
#define NET_BUFFER_SIZE 1024

static SOCKET client_socket;
static SOCKET listening_socket;

int initNetwork(int port){
	WORD sock_version;
	WSADATA wsa_data;
	int nret;
	sock_version = MAKEWORD(1, 1);
	WSAStartup(sock_version, &wsa_data);
	
	listening_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (listening_socket == INVALID_SOCKET) {
		nret = WSAGetLastError();
		WSACleanup();
		return NETWORK_ERROR;
	}
	SOCKADDR_IN serverInfo;
	serverInfo.sin_family = AF_INET;
	serverInfo.sin_addr.s_addr = INADDR_ANY;
	serverInfo.sin_port = htons(port);
	nret = bind(listening_socket, (LPSOCKADDR)&serverInfo, sizeof(struct sockaddr));
	if (nret == SOCKET_ERROR) {
		nret = WSAGetLastError();
		WSACleanup();
		return NETWORK_ERROR;
	}
	nret = listen(listening_socket, 1);
	if (nret == SOCKET_ERROR) {
		nret = WSAGetLastError();
		WSACleanup();
		return NETWORK_ERROR;
	}
	client_socket = accept(listening_socket, NULL, NULL);
	fprintf(stderr, "Got a connection!\n");
	if (client_socket == INVALID_SOCKET) {
		nret = WSAGetLastError();
		WSACleanup();
		return NETWORK_ERROR;
	}
	return NETWORK_OK;
}

void finiNetwork(){
	closesocket(client_socket);
	closesocket(listening_socket);
	WSACleanup();	
}

int sendNetwork(char* buffer){
	if(strlen(buffer) > NET_BUFFER_SIZE) return NETWORK_ERROR;	
	if (send(client_socket, buffer, strlen(buffer), 0) == SOCKET_ERROR) {
		return NETWORK_ERROR;
	}
	return NETWORK_OK;
}

int recvNetwork(char* buffer){
	int nret = recv(client_socket, buffer, NET_BUFFER_SIZE, 0);
	if (nret == SOCKET_ERROR || nret > NET_BUFFER_SIZE) {
		buffer[0] = 0;
		return NETWORK_ERROR;
	}
	buffer[nret] = 0;
	return NETWORK_OK;
}

